Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## weblogic.apache.xml.utils
Class SuballocatedIntVector

    java.lang.Object
      |
      +--weblogic.apache.xml.utils.SuballocatedIntVector

public class SuballocatedIntVector
extends java.lang.Object

A very simple table that stores a list of int. Very similar API to our IntVector class (same API); different internal storage. This version uses an array-of-arrays solution. Read/write access is thus a bit slower than the simple IntVector, and basic storage is a trifle higher due to the top-level array -- but appending is O(1) fast rather than O(N**2) slow, which will swamp those costs in situations where long vectors are being built up. Known issues: Some methods are private because they haven't yet been tested properly. Retrieval performance is critical, since this is used at the core of the DTM model. (Append performance is almost as important.) That's pushing me toward just letting reads from unset indices throw exceptions or return stale data; safer behavior would have performance costs.

This class is based on an implementation from the Apache XML Project. In future releases the XML parser, XSLT processor, and associated classes will likely be updated to be based on a later version of the Apache implementations. Since Apache does not guarantee backwards compatibility between versions of their software, we cannot guarantee backwards compatibility of any of the classes contained in the weblogic.apache package or sub-packages.

Field Summary
`protected int` | `m_blocksize` Size of blocks to allocate
`protected int` | `m_firstFree` Number of ints in array
`protected int[][]` | `m_map` Array of arrays of ints
`protected int[]` | `m_map0` "Shortcut" handle to m_map[0].
`protected int` | `m_MASK` Bitwise addressing (much faster than div/remainder
`protected int` | `m_numblocks` Number of blocks to (over)allocate by
`protected int` | `m_SHIFT` Bitwise addressing (much faster than div/remainder

Constructor Summary
`SuballocatedIntVector()` Default constructor.
`SuballocatedIntVector(int blocksize)` Construct a IntVector, using the given block size.
`SuballocatedIntVector(int blocksize, int increasesize)` Deprecated. use SuballocatedIntVector(int)

Method Summary
`void` | `addElement(int value)` Append a int onto the vector.
`int` | `elementAt(int i)` Get the nth element.
`int` | `indexOf(int elem)` Searches for the first occurence of the given argument, beginning the search at index, and testing for equality using the equals method.
`int` | `indexOf(int elem, int index)` Searches for the first occurence of the given argument, beginning the search at index, and testing for equality using the equals method.
`void` | `removeAllElements()` Wipe it out.
`void` | `setElementAt(int value, int at)` Sets the component at the specified index of this vector to be the specified object.
`int` | `size()` Get the length of the list.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### m_blocksize

    protected int m_blocksize

  Size of blocks to allocate

### m_SHIFT

    protected int m_SHIFT

  Bitwise addressing (much faster than div/remainder

### m_MASK

    protected int m_MASK

  Bitwise addressing (much faster than div/remainder

### m_numblocks

    protected int m_numblocks

  Number of blocks to (over)allocate by

### m_map

    protected int[][] m_map

  Array of arrays of ints

### m_firstFree

    protected int m_firstFree

  Number of ints in array

### m_map0

    protected int[] m_map0

  "Shortcut" handle to m_map[0]. Surprisingly helpful for short vectors.

Constructor Detail

### SuballocatedIntVector

    public SuballocatedIntVector()

  Default constructor. Note that the default block size is currently 2K, which may be overkill for small lists and undershootng for large ones.

### SuballocatedIntVector

    public SuballocatedIntVector(int blocksize)

  Construct a IntVector, using the given block size. For efficiency, we will round the requested size off to a power of two.

  Parameters:
    `blocksize` - Size of block to allocate

### SuballocatedIntVector

    public SuballocatedIntVector(int blocksize,
                                 int increasesize)

  Deprecated. use SuballocatedIntVector(int)
  We never _did_ use the increasesize parameter, so I'm phasing this constructor out.

  See Also:
    `SuballocatedIntVector(int)`

Method Detail

### size

    public int size()

  Get the length of the list.

  Returns:
    length of the list

### addElement

    public void addElement(int value)

  Append a int onto the vector.

  Parameters:
    `value` - Int to add to the list

### removeAllElements

    public void removeAllElements()

  Wipe it out. Currently defined as equivalent to setSize(0).

### setElementAt

    public void setElementAt(int value,
                             int at)

  Sets the component at the specified index of this vector to be the specified object. The previous component at that position is discarded. The index must be a value greater than or equal to 0 and less than the current size of the vector.

  Parameters:
    `node` - object to set
    `index` - Index of where to set the object

### elementAt

    public int elementAt(int i)

  Get the nth element. This is often at the innermost loop of an application, so performance is critical.

  Parameters:
    `i` - index of value to get
  Returns:
    value at given index. If that value wasn't previously set, the result is undefined for performance reasons. It may throw an exception (see below), may return zero, or (if setSize has previously been used) may return stale data.

### indexOf

    public int indexOf(int elem,
                       int index)

  Searches for the first occurence of the given argument, beginning the search at index, and testing for equality using the equals method.

  Parameters:
    `elem` - object to look for
    `index` - Index of where to begin search
  Returns:
    the index of the first occurrence of the object argument in this vector at position index or later in the vector; returns -1 if the object is not found.

### indexOf

    public int indexOf(int elem)

  Searches for the first occurence of the given argument, beginning the search at index, and testing for equality using the equals method.

  Parameters:
    `elem` - object to look for
  Returns:
    the index of the first occurrence of the object argument in this vector at position index or later in the vector; returns -1 if the object is not found.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at http://e-docs.bea.com/wls/docs70
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 BEA Systems, Inc. All Rights Reserved.
WebLogic Server 7.0 API Reference